      Member()

myDWORD                   EQUATE(ULONG)
myBOOL                    EQUATE(SIGNED)
myHANDLE                  EQUATE(UNSIGNED)


      Map
        module('')
          GetModuleFileName(Unsigned,*cString,uLong),uLong,PASCAL,RAW,NAME('GetModuleFileNameA')
          CreateToolhelp32Snapshot(myDWORD,myDWORD),myHANDLE,Pascal,Name('CreateToolhelp32Snapshot')
          Process32First(myHANDLE,uLong),myBool,Pascal,Name('Process32First')
          Process32Next(myHANDLE,uLong),myBool,Pascal,Name('Process32Next')
          CloseHandle(myHANDLE),myBOOL,PASCAL,RAW
          OutputDebugString(*cstring szOutputString),pascal,raw,name('OutputDebugStringA')
        end
      End

                Include('pids.inc'),once



!-----------------------------------------------------------------------------------
pidsclass.construct  procedure()
                code
                self.pidsq &= new (pidsqtype)
                if  self.pidsq &= null
                    self.debug('Failed to construct pids class')
                else
                    self.debug('Successfully instansiated pids class')
                end


pidsclass.destruct   procedure()
                code
                if ~self.pidsq &= null
                    free(self.pidsq)
                    dispose(self.pidsq)
                end
                self.debug('Destroyed pids class')

pidsclass.debug procedure(string pMsg,<string p1>,<string p2>,<string p3>,<string p4>)
Str             cstring(1024)
                code
                str = '[pids] ' & format(clock(),@t04) & ' ' & clip(pMsg)
                OutputDebugString(str)


pidsclass.IsRunning  procedure(string pPgmName)
                code
                self.snapshot()
                if  records(self.pidsQ)
                    self.pidsQ.pEntry32.szExeFile = upper(pPgmName)
                    get(self.pidsQ,self.pidsQ.pEntry32.szExeFile)
                    if ~errorcode()
                        self.debug(clip(pPgmName) & ' is already running')
                        return true
                    end
                end
                self.debug(clip(pPgmName) & ' is not running')
                return false

pidsclass.CountRunning  procedure(string pPgmName)
i               long
count           long(0)
                code
                self.snapshot()
                if  records(self.pidsQ)
                    loop i = 1 to records(self.pidsQ)
                        get(self.pidsQ,i)
                        if  self.pidsQ.pEntry32.szExeFile = upper(pPgmName)
                            count += 1
                        end
                    end
                end
                self.debug(count & ' copies of ' & clip(pPgmName) & ' is running')
                return count


pidsclass.Snapshot   PROCEDURE()
snapshothandle  unsigned
result          long(false)
                CODE
                free(self.pidsq)

                SnapshotHandle = CreateToolhelp32Snapshot(2h,0)
                If  SnapshotHandle = -1
                    self.debug('Unable to take memory snapshot of Processes')
                Else
                    self.pidsQ.pEntry32.dwsize = Size(self.pidsQ.pEntry32)
                    if ~Process32First(SnapshotHandle,Address(self.pidsQ.pEntry32))
                        self.debug('Process32First API Failed')
                    else
                        self.pidsQ.pEntry32.szExeFile = upper(self.pidsQ.pEntry32.szExeFile)
                        Add(self.pidsQ)
                        !self.debug('In Process : ' & clip(self.pidsQ.pEntry32.szExeFile))
                        Loop
                            If  Process32Next(SnapshotHandle,Address(self.pidsQ.pEntry32))
                                self.pidsQ.pEntry32.szExeFile = upper(self.pidsQ.pEntry32.szExeFile)
                                Add(self.pidsQ)
                                !self.debug('In Process : ' & clip(self.pidsQ.pEntry32.szExeFile))
                            Else
                                If  Records(self.pidsQ)
                                    Result = True
                                Else
                                    self.debug('Unable to find any Processes')
                                End
                                Break
                            End
                        End
                    End
                    If  CloseHandle(SnapShotHandle)
                    End
                End
                return result
